from PySZG import *
import random
import time

#Used to read in input
class tool:
    def __init__(self):
        #These are set true when a button is pressed
        #Must be reset outside of this class
	self.pressLeft = False
        self.pressRight = False
        self.pressLeft2 = False
        self.pressRight2 = False

    #Called by eventprocess
    def update(self, framework, event):
        #Only respond to button events when it is a
        #Mousedown event
	if event.getType() == AR_EVENT_BUTTON and event.getButton() == 0:
	    #getIndex = which button
            #In input simulator, different button sets
            #are selected by hitting space bar while in
            #mode 4 or 5.
	    if event.getIndex() == 0:
		self.pressLeft = True
	    elif event.getIndex() == 1:
		self.pressRight = True
            elif event.getIndex() == 2:
		self.pressLeft2 = True
	    elif event.getIndex() == 3:
		self.pressRight2 = True

    #SZG Framework calls this with an eventqueue
    def eventProcessing(self, framework, eventQueue):
        while not eventQueue.empty():
            e = eventQueue.popNextEvent()
            self.update(framework, e)
        return 1

f = arDistSceneGraphFramework();

#Make the tool so we can read input
theTool = tool()

#Set the event queue callback
f.setEventQueueCallback(theTool.eventProcessing)

if f.init(sys.argv) != 1:
    #Oh no....framework failed to initialize
    sys.exit()

#Must be operating a phleet
if f.getStandalone():
    print("This program only works in cluster mode. Please log in.")
    sys.exit()

#This is where the fun stuff begins
peer = arGraphicsPeer()
peer.setName("world1")
peer.queueData(0)
peer.init(f.getSZGClient())
#peer.setTexturePath("c:/szg-1.0/doc/python/texture")
peer.setTexturePath(f.getSZGClient().getAttribute("SZG_RENDER","texture_path"))
peer.loadAlphabet(f.getSZGClient().getAttribute("SZG_RENDER","text_path"))
#Set the peer to use our database
peer.setBridge(f.getDatabase())
#Set the root node from which we share
peer.setBridgeRootMapNode(f.getNavNode())

if peer.start() != 1:
    sys.exit()
if f.start() != 1:
    sys.exit()

if peer.connectToPeer("world0") < 0:
    print("Failed to connect to specified peer.")
    sys.exit()
else:
    print("Downloading from peer.")
    if peer.pullSerial("world0", 0, 0, AR_TRANSIENT_NODE, AR_TRANSIENT_NODE, AR_TRANSIENT_NODE) == 0:
	print("Error in downloading")

worldRoot = peer.find("world1")

balltrans = worldRoot.new("transform")

ballY = 5
ballV = 0

balltrans.set(ar_TM(3, ballY, -5))
ballmat = balltrans.new("material")
sphere = arSphereMesh(50)
sphere.attachMesh(ballmat)

bounce = False
filtering = False

balltrans.setNodeLevel(AR_TRANSIENT_NODE)

while 1:
    f.setViewer()
    f.setPlayer()
    f.processEventQueue()
    f.navUpdate()
	
    if theTool.pressLeft:
        theTool.pressLeft = False
        mat = arMaterial();
        mat.diffuse = arVector3(random.random(), random.random(), random.random())
        ballmat.set(mat)

    if theTool.pressRight:
        theTool.pressRight = False
        bounce = not bounce

    if bounce:
        ballY = ballY + ballV*.001
        ballV = ballV - 9.8*.001
        if ballY < 1.05:
            ballV = -ballV
        balltrans.set(ar_TM(3, ballY, -5))

    if theTool.pressLeft2:
        theTool.pressLeft2 = False
        filtering = not filtering
        if filtering:
            peer.remoteFilterDataBelow("world0", 0, AR_STABLE_NODE)
        else:
            peer.remoteFilterDataBelow("world0", 0, AR_TRANSIENT_NODE)
        
    f.loadNavMatrix()
    #time.sleep(0.01)

                                                                                                                                                                                                                                                                                                                                                                                                                                                         
